#define BLYNK_TEMPLATE_ID "TMPL6NdJR00eA"
#define BLYNK_DEVICE_NAME "monitoring"
#define BLYNK_AUTH_TOKEN "ZBIAsk5Cr47LKUDBlFJiYoMD4JxuP9fv"
#define BLYNK_PRINT Serial
#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>
#include <DHT.h>
#include <ThingESP.h>
#include <Arduino.h>
#include <IRremoteESP8266.h>
#include <IRsend.h>
#include <ir_Daikin.h>
#include <EEPROM.h>

#define DHTPIN 0
#define DHTTYPE DHT22

DHT dht(DHTPIN, DHTTYPE);
ThingESP8266 thing("olynda", "bot", "botwaarduino");
char auth[] = BLYNK_AUTH_TOKEN;
char ssid[] = "wireless@umsida.ac.id";
char pass[] = "AhmadDahlan1868";

int temp;
int hum;
int setValue;
String temps;
String tempbatas = "29";
int Switch;
int tambah;
int kurang;
int suhu;

bool flag1 = false;
byte value;

const uint16_t kIrLed = D2 ;  // ESP8266 GPIO pin to use. Recommended: 4 (D2).
IRDaikinESP ac(kIrLed);  // Set the GPIO to be used to sending the message
IRsend irsend(kIrLed);

BLYNK_WRITE(V2) {
  tambah = param.asInt();
  if (tambah == HIGH && Switch == HIGH) {
    suhu++;
    delay(200);
    if (suhu > 30) {
      suhu = 30;
    }
    EEPROM.write(0, suhu);
    EEPROM.commit();
    // Now send the IR signal.
#if SEND_DAIKIN
    ac.send();
#endif
  }
  else {
  }
}
BLYNK_WRITE(V3) {
  kurang = param.asInt();
  if (kurang == HIGH && Switch == HIGH) {
    suhu--;
    delay(200);
    if (suhu < 16) {
      suhu = 16;
    }
    EEPROM.write(0, suhu);
    EEPROM.commit();
    // Now send the IR signal.
#if SEND_DAIKIN
    ac.send();
#endif
  }
  else {
  }
}
BLYNK_WRITE(V4) {
  Switch = param.asInt();
  if (Switch == HIGH) {
    ac.on();
    ac.setTemp(value);
    Serial.println("AC hidup");
    // Now send the IR signal.
#if SEND_DAIKIN
    ac.send();
#endif
    delay(1000);
  }
  else {
    ac.off();
    Serial.println("AC mati");
    // Now send the IR signal.
#if SEND_DAIKIN
    ac.send();
#endif
    delay(1000);
  }
}

void setup() {
  Serial.begin(115200);
  EEPROM.begin(512);
  dht.begin();
  ac.begin();
  irsend.begin();
  Blynk.begin(auth, ssid, pass);
  Blynk.syncVirtual(V5);
  thing.SetWiFi(ssid, pass);
  thing.initDevice();
}

void loop() {
  hum = dht.readHumidity();
  temp = dht.readTemperature();
  if (isnan(hum) || isnan(temp)) {
    Serial.println("Failed to read from DHT sensor!");
    return;
  }
  temps = temp;
  value = EEPROM.read(0);
  Blynk.virtualWrite(V0, temp);
  Blynk.virtualWrite(V1, hum);
  Blynk.virtualWrite(V5, value);
  Serial.println(hum);
  Serial.println(temp);
  Blynk.run();
  thing.Handle();
  if (temp > 29 && flag1 == false) {
    String msg = "suhu ruangan sekarang diatas " + tempbatas + "*C\n"
                 + "Silahkan atur suhu ruangan anda sekarang";
    thing.sendMsg("6282330003007", msg);
    flag1 = true;
  }
  if (temp <= 29) {
    flag1 = false;
  }
  delay(100);
}   

String HandleResponse(String query)
{

  if (query == "test") {
    return "OK";
  }
  else if (query == "suhu sekarang") {
    return "suhu ruangan sekarang " + temps + "*C\n"
           + "set suhu air conditioner " + value + "*C";
  }
  else return "perintah tidak diketahui!";
}
